aboutsummaryrefslogtreecommitdiffstats
path: root/etc/init.d/zfs.gentoo.in
diff options
context:
space:
mode:
authorTurbo Fredriksson <[email protected]>2015-04-23 20:35:45 +0200
committerBrian Behlendorf <[email protected]>2015-05-28 14:14:53 -0700
commit2a34db1bdbcecf5019c4a59f2a44c92fe82010f2 (patch)
treed71451af8aa74837f6b1d434cae75e811778763d /etc/init.d/zfs.gentoo.in
parent544f7184f8541bbfd7c739f7e01fc9b5b6e57c5e (diff)
Base init scripts for SYSV systems
* Based on the init scripts included with Debian GNU/Linux, then take code from the already existing ones, trying to merge them into one set of scripts that will work for 'everyone' for better maintainability. * Add configurable variables to control the workings of the init scripts: * ZFS_INITRD_PRE_MOUNTROOT_SLEEP Set a sleep time before we load the module (used primarily by initrd scripts to allow for slower media (such as USB devices etc) to be availible before we load the zfs module). * ZFS_INITRD_POST_MODPROBE_SLEEP Set a timed sleep in the initrd to after the load of the zfs module. * ZFS_INITRD_ADDITIONAL_DATASETS To allow for mounting additional datasets in the initrd. Primarily used in initrd scripts to allow for when filesystem needed to boot (such as /usr, /opt, /var etc) isn't directly under the root dataset. * ZFS_POOL_EXCEPTIONS Exclude pools from being imported (in the initrd and/or init scripts). * ZFS_DKMS_ENABLE_DEBUG, ZFS_DKMS_ENABLE_DEBUG_DMU_TX, ZFS_DKMS_DISABLE_STRIP Set to control how dkms should build the dkms packages. * ZPOOL_IMPORT_PATH Set path(s) where "zpool import" should import pools from. This was previously the job of "USE_DISK_BY_ID" (which is still used for backwards compatibility) but was renamed to allow for better control of import path(s). * If old USE_DISK_BY_ID is set, but not new ZPOOL_IMPORT_PATH, then we set ZPOOL_IMPORT_PATH to sane defaults just to be on the safe side. * ZED_ARGS To allow for local options to zed without having to change the init script. * The import function, do_import(), imports pools by name instead of '-a' for better control of pools to import and from where. * If USE_DISK_BY_ID is set (for backwards compatibility), but isn't 'yes' then ignore it. * If pool(s) isn't found with a simple "zpool import" (seen it happen), try looking for them in /dev/disk/by-id (if it exists). Any duplicates (pools found with both commands) is filtered out. * IF we have found extra pool(s) this way, we must force USE_DISK_BY_ID so that the first, simple "zpool import $pool" is able to find it. * Fallback on importing the pool using the cache file (if it exists) only if 'simple' import (either with ZPOOL_IMPORT_PATH or the 'built in' defaults) didn't work. * The export function, do_export(), will export all pools imported, EXCEPT the root pool (if there is one). * ZED script from the Debian GNU/Linux packages added. * Refreshed ZED init script from behlendorf@5e7a660 to be portable so it may be used on both LSB and Redhat style systems. * If there is no pool(s) imported and zed successfully shut down, we will unload the zfs modules. * The function library file for the ZoL init script is installed as /etc/init.d/zfs-functions. * The four init scripts, the /etc/{defaults,sysconfig,conf.d}/zfs config file as well as the common function library is tagged as '%config(noreplace)' in the rpm rules file to make sure they are not replaced automatically if locally modifed. * Pitfals and workarounds: * If we're running from init, remove stale /etc/dfs/sharetab before importing pools in the zfs-import init script. * On Debian GNU/Linux, there's a 'sendsigs' script that will kill basically everything quite early in the shutdown phase and zed is/should be stopped much later than that. We don't want zed to be among the ones killed, so add the zed pid to list of pids for 'sendsigs' to ignore. * CentOS uses echo_success() and echo_failure() to print out status of command. These in turn uses "echo -n \0xx[etc]" to move cursor and choose colour etc. This doesn't work with the modified IFS variable we need to use in zfs-import for some reason, so work around that when we define zfs_log_{end,failure}_msg() for RedHat and derivative distributions. * All scripts passes ShellCheck (with one false positive in do_mount()). Signed-off-by: Turbo Fredriksson [email protected] Signed-off-by: Brian Behlendorf <[email protected]> Reviewed by: Richard Yao <[email protected]> Reviewed by: Chris Dunlap <[email protected]> Closes #2974 Closes #2107
Diffstat (limited to 'etc/init.d/zfs.gentoo.in')
-rw-r--r--etc/init.d/zfs.gentoo.in124
1 files changed, 0 insertions, 124 deletions
diff --git a/etc/init.d/zfs.gentoo.in b/etc/init.d/zfs.gentoo.in
deleted file mode 100644
index 07fce01ba..000000000
--- a/etc/init.d/zfs.gentoo.in
+++ /dev/null
@@ -1,124 +0,0 @@
-#!/sbin/runscript
-# Copyright 1999-2011 Gentoo Foundation
-# Released under the 2-clause BSD license.
-# $Header: /var/cvsroot/gentoo-x86/sys-fs/zfs/files/zfs,v 0.9 2011/04/30 10:13:43 devsk Exp $
-
-if [ -z "$init" ]; then
- # Not interactive
- grep -qE '(^|[^\\](\\\\)* )zfs=(off|no)( |$)' /proc/cmdline && exit 3
-fi
-
-depend()
-{
- # Try to allow people to mix and match fstab with ZFS in a way that makes sense.
- if [ "$(mountinfo -s /)" = 'zfs' ]
- then
- before localmount
- else
- after localmount
- fi
-
- # bootmisc will log to /var which may be a different zfs than root.
- before bootmisc logger
- use mtab
- keyword -lxc -openvz -prefix -vserver
-}
-
-ZFS="@sbindir@/zfs"
-ZPOOL="@sbindir@/zpool"
-ZPOOL_CACHE="@sysconfdir@/zfs/zpool.cache"
-ZFS_MODULE=zfs
-
-checksystem() {
- if [ ! -c /dev/zfs ]; then
- einfo "Checking if ZFS modules present"
- if ! modinfo zfs > /dev/null 2>&1 ; then
- eerror "$ZFS_MODULE not found. Is the ZFS package installed?"
- return 1
- fi
- fi
- einfo "Checking if zfs userspace tools present"
- if [ ! -x $ZPOOL ]; then
- eerror "$ZPOOL binary not found."
- return 1
- fi
- if [ ! -x $ZFS ]; then
- eerror "$ZFS binary not found."
- return 1
- fi
- return 0
-}
-
-start() {
- ebegin "Starting ZFS"
- checksystem || return 1
-
- # Delay until all required block devices are present.
- udevadm settle
-
- if [ ! -c /dev/zfs ]; then
- modprobe $ZFS_MODULE
- rv=$?
- if [ $rv -ne 0 ]; then
- eerror "Failed to load the $ZFS_MODULE module, check 'dmesg|tail'."
- eend $rv
- return $rv
- fi
- fi
-
- # Import all pools described by the cache file, and then mount
- # all filesystem based on their properties.
- if [ -f $ZPOOL_CACHE ]; then
- einfo "Importing ZFS pools"
- # as per fedora script, import can fail if all pools are already imported
- # The check for $rv makes no sense...but someday, it will work right.
- $ZPOOL import -c $ZPOOL_CACHE -aN 2>/dev/null || true
- rv=$?
- if [ $rv -ne 0 ]; then
- eerror "Failed to import not-yet imported pools."
- eend $rv
- return $rv
- fi
- fi
-
- einfo "Mounting ZFS filesystems"
- $ZFS mount -a
- rv=$?
- if [ $rv -ne 0 ]; then
- eerror "Failed to mount ZFS filesystems."
- eend $rv
- return $rv
- fi
-
- einfo "Exporting ZFS filesystems"
- $ZFS share -a
- rv=$?
- if [ $rv -ne 0 ]; then
- eerror "Failed to export ZFS filesystems."
- eend $rv
- return $rv
- fi
-
- eend 0
- return 0
-}
-
-stop()
-{
- ebegin "Unmounting ZFS filesystems"
- $ZFS umount -a
- rv=$?
- if [ $rv -ne 0 ]; then
- einfo "Some ZFS filesystems not unmounted"
- fi
-
- # Don't fail if we couldn't umount everything. /usr might be in use.
- eend 0
- return 0
-}
-
-status()
-{
- # show pool status and list
- $ZPOOL status && echo && $ZPOOL list
-}